subroutine read_dist(sampe,sampa)
  
  use parameters
  use economy
  
  
  real(8)::sampa(nsamp), shocks(nsamp), shocks2(nsamp), mucum(ne)
  integer::sampe(nsamp), ie, isamp, ninit
  real(8),allocatable,dimension(:):: dgrid
  real(8),allocatable,dimension(:,:):: dist
  
  integer:: iline, distn
  integer:: dist_in=31
  character(15):: dist_inname="distA.txt"
  
  
  mucum=mu
  do ie=2,ne
     mucum(ie)=mucum(ie-1)+mu(ie)
  end do
  
  open(dist_in,file=dist_inname)
  read(dist_in,*) distn
  allocate(dgrid(distn),dist(3,distn))
  
  do iline=1,distn
     read(dist_in,*) dgrid(iline), (dist(ie,iline),ie=1,3)
  end do
  close(dist_in)
  
  call random_init
  call random_number(shocks)
  call random_number(shocks2)
  
  sample_loop: do isamp=1,nsamp
     do ie=1,ne
        if (shocks(isamp) .le. mucum(ie)) then
           sampe(isamp)=ie
           exit
        endif
     end do
     shocks2(isamp)=shocks2(isamp)*mu(ie)
     do ix=1,distn
        if (shocks2(isamp) .le. dist(ie,ix)) then
           if (ix==1) sampa(isamp)= dgrid(1)
           if (ix>1) sampa(isamp)=interpol(dist(ie,ix-1),dist(ie,ix),dgrid(ix-1),dgrid(ix),shocks2(isamp))
           exit
        end if
     end do
  end do sample_loop
  
end subroutine read_dist
